'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createConversionContext;

var _ConversionContext = require('./ConversionContext');

var _ConversionContext2 = _interopRequireDefault(_ConversionContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createConversionContext(options) {

  var context = new _ConversionContext2.default();

  if ('suppressComments' in options && Array.isArray(options.suppressComments)) {
    context.suppressCommentPatterns = options.suppressComments.map(function (regexString) {
      return new RegExp(regexString);
    });
  }

  if ('suppressTypes' in options && Array.isArray(options.suppressTypes)) {
    context.suppressTypeNames = options.suppressTypes;
  }

  return context;
}