'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTypeParameters = exports.findIdentifiers = exports.transform = undefined;
exports.default = babelPluginFlowPrepack;

var _createConversionContext = require('./createConversionContext');

var _createConversionContext2 = _interopRequireDefault(_createConversionContext);

var _collectProgramOptions = require('./collectProgramOptions');

var _collectProgramOptions2 = _interopRequireDefault(_collectProgramOptions);

var _firstPassVisitors = require('./firstPassVisitors');

var _firstPassVisitors2 = _interopRequireDefault(_firstPassVisitors);

var _transformVisitors = require('./transformVisitors');

var _transformVisitors2 = _interopRequireDefault(_transformVisitors);

var _transform = require('./transform');

var _transform2 = _interopRequireDefault(_transform);

var _findIdentifiers = require('./findIdentifiers');

var _findIdentifiers2 = _interopRequireDefault(_findIdentifiers);

var _getTypeParameters = require('./getTypeParameters');

var _getTypeParameters2 = _interopRequireDefault(_getTypeParameters);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function babelPluginFlowPrepack() {
  return {
    visitor: {
      Program: function Program(path, state) {
        var opts = state.opts;

        var context = (0, _createConversionContext2.default)(opts || {});
        if (!(0, _collectProgramOptions2.default)(context, path.node)) {
          return;
        }
        path.traverse((0, _firstPassVisitors2.default)(context));
        path.traverse((0, _transformVisitors2.default)(context));
      }
    }
  };
}

exports.transform = _transform2.default;
exports.findIdentifiers = _findIdentifiers2.default;
exports.getTypeParameters = _getTypeParameters2.default;